# strahlenschutz
Daten zur radioaktiven Belastung in Deutschland. Weitere Informationen unter https://odlinfo.bfs.de/ODL/DE/service/datenschnittstelle/datenschnittstelle_node.html.

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python >= 3.6

## Installation & Usage
### pip install

```sh
pip install deutschland[strahlenschutz]
```

### poetry install

```sh
poetry add deutschland -E strahlenschutz
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

## Usage

Import the package:
```python
from deutschland import strahlenschutz
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
from deutschland import strahlenschutz
from pprint import pprint
from deutschland.strahlenschutz.api import default_api
from deutschland.strahlenschutz.model.extended_schema import ExtendedSchema
from deutschland.strahlenschutz.model.normal_schema import NormalSchema
# Defining the host is optional and defaults to https://www.imis.bfs.de/ogc/opendata/ows
# See configuration.py for a list of all supported configuration parameters.
configuration = strahlenschutz.Configuration(
    host = "https://www.imis.bfs.de/ogc/opendata/ows"
)



# Enter a context with an instance of the API client
with strahlenschutz.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = default_api.DefaultApi(api_client)
    service = "WFS" # str | Name des Service der benutzt werden soll. Aktuell immer `WFS`. (default to "WFS")
request = "GetFeature" # str | Name der OWS-Request. Aktuell immer `GetFeature`. (default to "GetFeature")
output_format = "application/json" # str | Ausgabeformat. Aktuell immer `application/json`. (default to "application/json")
type_name = "opendata:odlinfo_odl_1h_latest" # str | Name des Datenlayers, das benutzt werden soll.   * `odlinfo_odl_1h_latest` - Liste der Messstellen inklusive dem jeweils letzten 1-Stunden-Messwert   * `odlinfo_timeseries_odl_1h` - Zeitreihe mit 1-Stunden-Messdaten   * `odlinfo_timeseries_odl_24h` - Zeitreihe mit 24-Stunden-Messdaten  (optional)
viewparams = "kenn:031020004" # str | Nur in Kombination mit historischen Daten (also nur Layer ohne `_latest`) relevant.  Genutzt zur Angabe einer spezifischen Messstelle mittels `kenn`-Wert.  (optional)
sort_by = "end_measure+D" # str | Hier kann ein Feld von `properties` (also den zurückgegebenen Datenpunkten) angegeben werden, dann wird nach diesem aufsteigend sortiert. Wird an den Namen des Feldes noch `+D` angehängt, so wird absteigend sortiert.  (optional)
max_features = 100 # float | Maximale Anzahl an Datenpunkten die zurückgegeben werden soll. (optional)
start_index = 3.14 # float | Offset, von dem aus Datenpunkte zurückgegeben werden sollen. Kann in Kombination mit `maxFeatures` genutzt werden, um Pagination zu ermöglichen. (optional)

    try:
        # Hauptendpunkt
        api_response = api_instance.root_get(service, request, output_format, type_name=type_name, viewparams=viewparams, sort_by=sort_by, max_features=max_features, start_index=start_index)
        pprint(api_response)
    except strahlenschutz.ApiException as e:
        print("Exception when calling DefaultApi->root_get: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://www.imis.bfs.de/ogc/opendata/ows*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**root_get**](docs/DefaultApi.md#root_get) | **GET** / | Hauptendpunkt


## Documentation For Models

 - [BaseFeature](docs/BaseFeature.md)
 - [BaseSchema](docs/BaseSchema.md)
 - [ExtendedFeature](docs/ExtendedFeature.md)
 - [ExtendedFeatureProperties](docs/ExtendedFeatureProperties.md)
 - [ExtendedSchema](docs/ExtendedSchema.md)
 - [GeometryPoint](docs/GeometryPoint.md)
 - [NormalFeature](docs/NormalFeature.md)
 - [NormalFeatureProperties](docs/NormalFeatureProperties.md)
 - [NormalSchema](docs/NormalSchema.md)


## Documentation For Authorization

 All endpoints do not require authorization.

## Author

kontakt@bund.dev


## Notes for Large OpenAPI documents
If the OpenAPI document is large, imports in strahlenschutz.apis and strahlenschutz.models may fail with a
RecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:

Solution 1:
Use specific imports for apis and models like:
- `from deutschland.strahlenschutz.api.default_api import DefaultApi`
- `from deutschland.strahlenschutz.model.pet import Pet`

Solution 2:
Before importing the package, adjust the maximum recursion limit as shown below:
```
import sys
sys.setrecursionlimit(1500)
from deutschland import strahlenschutz
from deutschland.strahlenschutz.apis import *
from deutschland.strahlenschutz.models import *
```

