# -*- coding: utf-8 -*-
from setuptools import setup

packages = \
['deutschland',
 'deutschland.strahlenschutz',
 'deutschland.strahlenschutz.api',
 'deutschland.strahlenschutz.apis',
 'deutschland.strahlenschutz.model',
 'deutschland.strahlenschutz.models']

package_data = \
{'': ['*']}

install_requires = \
['python-dateutil', 'urllib3>=1.25.3']

setup_kwargs = {
    'name': 'de-strahlenschutz',
    'version': '1.0.0',
    'description': 'ODL-Info API',
    'long_description': '# strahlenschutz\nDaten zur radioaktiven Belastung in Deutschland. Weitere Informationen unter https://odlinfo.bfs.de/ODL/DE/service/datenschnittstelle/datenschnittstelle_node.html.\n\nThis Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:\n\n- API version: 1.0.0\n- Package version: 1.0.0\n- Build package: org.openapitools.codegen.languages.PythonClientCodegen\n\n## Requirements.\n\nPython >= 3.6\n\n## Installation & Usage\n### pip install\n\n```sh\npip install deutschland[strahlenschutz]\n```\n\n### poetry install\n\n```sh\npoetry add deutschland -E strahlenschutz\n```\n\n### Setuptools\n\nInstall via [Setuptools](http://pypi.python.org/pypi/setuptools).\n\n```sh\npython setup.py install --user\n```\n(or `sudo python setup.py install` to install the package for all users)\n\n## Usage\n\nImport the package:\n```python\nfrom deutschland import strahlenschutz\n```\n\n## Getting Started\n\nPlease follow the [installation procedure](#installation--usage) and then run the following:\n\n```python\n\nimport time\nfrom deutschland import strahlenschutz\nfrom pprint import pprint\nfrom deutschland.strahlenschutz.api import default_api\nfrom deutschland.strahlenschutz.model.extended_schema import ExtendedSchema\nfrom deutschland.strahlenschutz.model.normal_schema import NormalSchema\n# Defining the host is optional and defaults to https://www.imis.bfs.de/ogc/opendata/ows\n# See configuration.py for a list of all supported configuration parameters.\nconfiguration = strahlenschutz.Configuration(\n    host = "https://www.imis.bfs.de/ogc/opendata/ows"\n)\n\n\n\n# Enter a context with an instance of the API client\nwith strahlenschutz.ApiClient(configuration) as api_client:\n    # Create an instance of the API class\n    api_instance = default_api.DefaultApi(api_client)\n    service = "WFS" # str | Name des Service der benutzt werden soll. Aktuell immer `WFS`. (default to "WFS")\nrequest = "GetFeature" # str | Name der OWS-Request. Aktuell immer `GetFeature`. (default to "GetFeature")\noutput_format = "application/json" # str | Ausgabeformat. Aktuell immer `application/json`. (default to "application/json")\ntype_name = "opendata:odlinfo_odl_1h_latest" # str | Name des Datenlayers, das benutzt werden soll.   * `odlinfo_odl_1h_latest` - Liste der Messstellen inklusive dem jeweils letzten 1-Stunden-Messwert   * `odlinfo_timeseries_odl_1h` - Zeitreihe mit 1-Stunden-Messdaten   * `odlinfo_timeseries_odl_24h` - Zeitreihe mit 24-Stunden-Messdaten  (optional)\nviewparams = "kenn:031020004" # str | Nur in Kombination mit historischen Daten (also nur Layer ohne `_latest`) relevant.  Genutzt zur Angabe einer spezifischen Messstelle mittels `kenn`-Wert.  (optional)\nsort_by = "end_measure+D" # str | Hier kann ein Feld von `properties` (also den zurückgegebenen Datenpunkten) angegeben werden, dann wird nach diesem aufsteigend sortiert. Wird an den Namen des Feldes noch `+D` angehängt, so wird absteigend sortiert.  (optional)\nmax_features = 100 # float | Maximale Anzahl an Datenpunkten die zurückgegeben werden soll. (optional)\nstart_index = 3.14 # float | Offset, von dem aus Datenpunkte zurückgegeben werden sollen. Kann in Kombination mit `maxFeatures` genutzt werden, um Pagination zu ermöglichen. (optional)\n\n    try:\n        # Hauptendpunkt\n        api_response = api_instance.root_get(service, request, output_format, type_name=type_name, viewparams=viewparams, sort_by=sort_by, max_features=max_features, start_index=start_index)\n        pprint(api_response)\n    except strahlenschutz.ApiException as e:\n        print("Exception when calling DefaultApi->root_get: %s\\n" % e)\n```\n\n## Documentation for API Endpoints\n\nAll URIs are relative to *https://www.imis.bfs.de/ogc/opendata/ows*\n\nClass | Method | HTTP request | Description\n------------ | ------------- | ------------- | -------------\n*DefaultApi* | [**root_get**](docs/DefaultApi.md#root_get) | **GET** / | Hauptendpunkt\n\n\n## Documentation For Models\n\n - [BaseFeature](docs/BaseFeature.md)\n - [BaseSchema](docs/BaseSchema.md)\n - [ExtendedFeature](docs/ExtendedFeature.md)\n - [ExtendedFeatureProperties](docs/ExtendedFeatureProperties.md)\n - [ExtendedSchema](docs/ExtendedSchema.md)\n - [GeometryPoint](docs/GeometryPoint.md)\n - [NormalFeature](docs/NormalFeature.md)\n - [NormalFeatureProperties](docs/NormalFeatureProperties.md)\n - [NormalSchema](docs/NormalSchema.md)\n\n\n## Documentation For Authorization\n\n All endpoints do not require authorization.\n\n## Author\n\nkontakt@bund.dev\n\n\n## Notes for Large OpenAPI documents\nIf the OpenAPI document is large, imports in strahlenschutz.apis and strahlenschutz.models may fail with a\nRecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:\n\nSolution 1:\nUse specific imports for apis and models like:\n- `from deutschland.strahlenschutz.api.default_api import DefaultApi`\n- `from deutschland.strahlenschutz.model.pet import Pet`\n\nSolution 2:\nBefore importing the package, adjust the maximum recursion limit as shown below:\n```\nimport sys\nsys.setrecursionlimit(1500)\nfrom deutschland import strahlenschutz\nfrom deutschland.strahlenschutz.apis import *\nfrom deutschland.strahlenschutz.models import *\n```\n\n',
    'author': 'BundesAPI',
    'author_email': 'kontakt@bund.dev',
    'maintainer': None,
    'maintainer_email': None,
    'url': 'https://github.com/bundesAPI/strahlenschutz-api',
    'packages': packages,
    'package_data': package_data,
    'install_requires': install_requires,
    'python_requires': '>=3.6',
}


setup(**setup_kwargs)
